var backgroundCol = [];
var pupX = 200;
var pupY = 0;
var balloonX;
var sit = 0;
var r = 0;
var direction = 0;
var score = 0;

var alphaIndexesPup = [
    0, 0, 0, 0, 1, 0, 0, 0, 1, 0,
    0, 0, 0, 0, 1, 1, 1, 1, 1, 0,
    0, 0, 0, 0, 1, 1, 1, 1, 1, 0,
    0, 0, 0, 0, 1, 1, 1, 1, 1, 0,
    0, 0, 0, 0, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0,
    0, 1, 1, 1, 1, 1, 1, 1, 0, 0,
    0, 1, 0, 1, 0, 1, 0, 1, 0, 0];
var colorIndexesPup = [
    0, 0, 0, 0, 80, 0, 0, 0, 80, 0,
    0, 0, 0, 0, 80, 80, 80, 80, 80, 0,
    0, 0, 0, 0, 100, 110, 80, 80, 110, 0,
    0, 0, 0, 0, 100, 100, 10, 100, 10, 0,
    0, 0, 0, 0, 100, 100, 110, 100, 100, 10,
    100, 100, 100, 100, 100, 100, 110, 130, 130, 130,
    80, 100, 100, 100, 100, 100, 130, 130, 0, 0,
    80, 100, 100, 100, 100, 100, 130, 130, 0, 0,
    0, 100, 110, 110, 110, 100, 130, 130, 0, 0,
    0, 100, 0, 90, 0, 100, 0, 90, 0, 0];


var alphaIndexesBalloon = [
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 1, 1, 1, 0, 0, 0, 0, 0,
    0, 1, 1, 1, 1, 1, 0, 0, 0, 0,
    1, 1, 1, 1, 1, 1, 1, 0, 0, 0,
    1, 1, 1, 1, 1, 1, 1, 0, 0, 0,
    1, 1, 1, 1, 1, 1, 1, 0, 0, 0,
    0, 1, 1, 1, 1, 1, 0, 0, 0, 0,
    0, 0, 1, 1, 1, 0, 0, 0, 0, 0,
    0, 0, 0, 1, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 1, 1, 0, 0, 0, 0];
var colorIndexesBalloon = [
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 5, 5, 5, 0, 0, 0, 0, 0,
    0, 5, "red", "red", "red", 5, 0, 0, 0, 0,
    5, "red", "red", "red", 255, "red", 5, 0, 0, 0,
    5, "red", "red", "red", "red", "red", 5, 0, 0, 0,
    5, "red", "red", "red", "red", "red", 5, 0, 0, 0,
    0, 5, "red", "red", "red", 5, 0, 0, 0, 0,
    0, 0, 5, 5, 5, 0, 0, 0, 0, 0,
    0, 0, 0, 5, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 5, 5, 0, 0, 0, 0];

var bouncy_background;
var poppy;


function setup() {
    createCanvas(480, 480);
    frameRate(60);

    for (var q = 0; q < 96*96; q++) {
        backgroundCol[q] = 200 + random(-10,10);
    }    

    balloonX = 100;

    bouncy_background = loadSound("bouncy_background.mp3");
    poppy = loadSound("pop.wav");


    bouncy_background.setVolume(0.5);
    poppy.setVolume(100);

}


function draw() {
    backdrop();

    bouncy_background.play();

    fill(0);
    textSize(20);
    textAlign(CENTER);
    text("Move with the     ltshserh and right arrow keys! < >", width/2, height/4 - 50);
    text("Sit on the balloons with 'Enter'", width/2, height/4 - 30);


    if ( (sit%2 == 1) && (abs(pupX - (balloonX + 12)) <= 30) ) {

        balloonX = random(50, width-50);
        poppy.play();
        score += 1;

    }

    text("Score = " + str(score), width/2, 3*height/4 - 20);

    if (score == 10) {

        balloonX = -50;

        rectMode(CENTER);
        fill("green");
        rect(width/2, 3*height/4 + 25, 120, 40);
        fill(0);
        text("Restart", width/2, 3*height/4 + 30);

    }
   

    balloon(balloonX);
    
    
    if (direction == 1) {

        push();
        translate(pupX,200 + r);
        scale(-1,1);
        pup(0,0);
        pop();

    } else {
        pup(pupX, pupY + 200 + r);
    }


    


}


function pixelRGB(x,y,r,g,b) {

    //Makes a pixel with length and size of 5 to construct
    //other images

    fill(r,g,b);
    noStroke();
    rect(x,y,5,5);

}

function pixelOne(x,y,col) {

    //Makes a pixel with length and size of 5 to construct
    //other images

    fill(col);
    noStroke();
    rect(x,y,5,5);

}


function backdrop() {

    //Makes the fuzzy background
    for (var y = 0; y < 96; y++) {
        for (var x = 0; x < 96; x++) {
            pixelOne(x*5,y*5,backgroundCol[96*y + x]);
        }
    }
}

function pup(x,y) {

    //Makes a character at x, y with color
    //Drawn pixel by pixel

    for (var g = 0; g < 100; g++) {

        if (alphaIndexesPup[g] == 1) {

            pixelOne((g%10)*5 + x,(floor(g/10))*5 + y,colorIndexesPup[g]);

        }
    }
}

function balloon(x) {

    for (var q = 0; q < 100; q++) {

        if (alphaIndexesBalloon[q] == 1) {

            pixelOne((q%10)*5 + x,(floor(q/10))*5 + 200,colorIndexesBalloon[q]);

        }
    }

}



function keyPressed() {

    if (keyCode === LEFT_ARROW) {
        
        if (sit%2 == 0) {
            
            if (direction == 0) {
                direction = 1;
                pupX += 25;
            } else {
                pupX -= 25;
            }
        }

    } else if (keyCode === RIGHT_ARROW) {

        if (sit%2 == 0) {

            if (direction == 1) {
                direction = 0;
                pupX -= 25;
            } else {
                pupX += 25;
            }
        }
    }


    if ( pupX >= (width - 50) ) {

        pupX = (width - 50);

    } else if ( pupX <= 50 ) {

        pupX = 50;

    }


    if (keyCode === RETURN) {
        sit += 1;
    }

    if (sit%2 == 1) {

        r = 5;
        alphaIndexesPup[91] = 0;
        alphaIndexesPup[93] = 0;
        alphaIndexesPup[95] = 0;
        alphaIndexesPup[97] = 0;

    } else {

        r = 0;
        alphaIndexesPup[91] = 1;
        alphaIndexesPup[93] = 1;
        alphaIndexesPup[95] = 1;
        alphaIndexesPup[97] = 1;

    }
}

function mousePressed() {

    if ( (score >= 10) && ( (mouseX <= 300) && 
        (mouseX >= 300) ) && ( (mouseY <= 405) && 
        (mouseY >= 405) ) ) {

        balloonX = 100;
        pupX = 240;
        score = 0;

    }
}



//ADD MODES IN DRAW
//ADD SOUNDS LIKE BACKGROUND MUSIC AND POPS
//Make a computational animation 
//when each balloon pops for more complexity